;----------------------------------------------------+
;                                                    |
;   MakeBlk.lsp                                      |
;                                                    |
;   Written by Scott Barrow,  April 1988             |
;                                                    |
;----------------------------------------------------+

(defun MakeBlk (/ oldmode blkent blkpt blknam dirpath)

   ; ** Get input from operator, which block to define, or redefine
   (initget (+ 1 2 4)) ; ** disallow null, zero or negative values
   (setq blknam (strcat "block" (itoa 
                (getint "\nEnter User Block number to create (1-15): "))))

   ; ** directory where block to be stored, modify if necessary
   (setq dirpath "C:/blocks/")

   ; ** Get entities to make up the block
   (setq blkent (ssget))

   ; ** check to make sure at least some entities were selected
   (if blkent
     (progn

       ; ** get block insertion point
       (initget 1) ;** disallow null values
       (setq blkpt (getpoint "\nEnter block insertion base point: "))

       ; ** set modes
       (setq oldmode (getvar "REGENMODE"))
       (setvar "REGENMODE" 0)  ; ** disallow regens
       (setvar "EXPERT" 2)     ; ** allow for redefining blocks, wblocks
       (setvar "CMDECHO" 0)    ; ** disallow command messages

       ; ** make a slide from current view on screen
       (command "MSLIDE" (strcat dirpath blknam))

       ; ** define, or re-define the block
       (command "BLOCK" blknam blkpt blkent "")

       ; ** write created block to a drawing file
       (command "WBLOCK" (strcat dirpath blknam) blknam)

       ; ** reset modes
       (setvar "REGENMODE" oldmode)
       (setvar "EXPERT" 1)

     )
   )
   ; ** all done

   (prompt "\nDone with Make User Block command.")
   (princ) ; ** exit without NIL
)

