; *** SCRNINP.LSP ***
;
; *** SCREEN-ICON ROUTINE ***
; *** THIS AUTOLISP PROGRAM, WHEN USED WITH ASSOCIATED MENU ***
; *** AND SLIDES, ALLOWS ONSCREEN SYMBOL SELECTION ***
; *** FROM AN (N X N) MATRIX ***
;
; PROGRAMMED 1987 BY KEN SEGAL
; COPYRIGHT 1987 SPACE DESIGN INCORPORATED
; ALL RIGHTS RESERVED
;
;******************************************************************

(DEFUN C:SCRNINP (/ SLIDEHGT SLIDEWID XMIN YMIN GRX GRY A CELLX CELLY)
;
; *** GRIDNUM, SLIDENAM & SYMLIST ARE SET BY MENU PICK ***
; *** BEFORE INVOKING THIS ROUTINE ***
;
; *** GRIDNUM IS NUMBER OF ELEMENTS ACROSS OR DOWN IN GRID ***
; *** SLIDENAM IS NAME OF SLIDE TO VIEW ***
; *** SYMLIST IS A PASSED LIST OF SYMBOLS IN GRID ***
;
(SETVAR "CMDECHO" 0)
(COMMAND "VSLIDE" SLIDENAM)
(PRINT)
(PROMPT "SELECT SYMBOL FROM SCREEN ICON:")
;
; *** SETTING UP SCREEN-AREA PROPORTION, VIEWING SLIDE ***
; *** AND INPUTTING USER'S ICON PICK ***
;
(SETQ
   SLIDEHGT (getvar "viewsize")
SLIDEWID (* slidehgt(/(-(car(getvar "vsmax"))(car(getvar "vsmin")))
              (- (cadr (getvar "vsmax")) (cadr (getvar "vsmin")))))
   XMIN (- (car (getvar "viewctr")) (/ slidewid 2.0))
   YMIN (- (cadr (getvar "viewctr")) (/ slidehgt 2.0))
   A NIL GRX NIL GRY NIL
   A (GRREAD)
)
;
; *** IF PICK IS FROM KEYBOARD OR OTHERWISE NOT FROM ***
; *** SCREEN AREA, FUNCTION WILL CLEAR, AND RETURN ***
; *** ILLEGAL SYMBOL NUMBER, OR "NIL" RESPONSE ***
;
(IF (NOT(EQUAL(CAR A) 3)) (PROGN (SETQ SYMNUM 0) (SETQ A NIL)))
(IF (NOT(EQUAL A NIL))
;
; *** IF ICON IS PICKED, RETURN X AND Y COORDINATES, ***
; *** FIND THEIR RELATIVE "CELL NUMBER" IN ARRAY, ***
; *** AND CONVERT TO SYMNUM, OR SYMBOL NUMBER IN LIST ***
;
(PROGN
(SETQ
   GRX (- (CAADR A) XMIN)
   GRY (- (CADADR A) YMIN)
   CELLX (FIX(+ 1.0(* GRIDNUM(/ GRX SLIDEWID))))
   CELLY (- (1+ GRIDNUM)(FIX(+ 1.0(* GRIDNUM(/ GRY SLIDEHGT)))))
   SYMNUM (+ CELLX (* (- CELLY 1) GRIDNUM))
;
;
; *** PROGRAM RETURNS SYMNUM, NUMBER OF SYMBOL PICKED FROM ***
; *** MENU PICK THEN PERFORMS APPROPRIATE ROUTINE OR SYMBOL ***
; *** INSERTION FROM "SYMLIST" ***
;
)
)
)
(COMMAND "REDRAW")
(SETVAR "CMDECHO" 1)
(PRINT)
)

