#: 3878 S0/General Information
    06-Sep-86  05:34:08
Sb: Lisp at ACAD Prompts
Fm: TONY TANZILLO 70307,2556
To: ALL

Here is another neat little "trick" that can be used at ANY AutoCAD
"point:" prompt. It permits you to provide a relative polar point
specification without knowing the distance. It will allow you to
"measure" a distance between any two objects on the display which
can be osnapped to. It will return a point coordinate which is at
the angle you specify, and a distance equal to the distance measured.
 
(defun measure()
  (polar
    (getvar "lastpoint")
    (getangle (getvar "lastpoint") "Angle: ")
    (getdist "Measure Distance: ")
  )
)
 
To use this function, simply reply with "(MEASURE) <cr>" to
any AutoCAD "point:" prompt (i.e. line from point:, to point:, etc.)
and you will be prompted for an angle with the base point anchored
to the lastpoint.  After You supply the angle, You will be prompted
for a distance. You can specify any to points on the display using
object snap to "Measure" a distance between two objects which have
no relation to the points you are working with.
 
I am interested in hearing from all You AutoLISP Wizards on what
other Interesting functions You've come up with specifically for use
at an an AutoCAD Prompt (a.k.a "Nested Commands" <take that VersaCAD !> ).
 
(IDEAS: change the current drawing layer in the middle of a command,
or change one or all of the current line properties in the middle of
a command, how about panning and zooming while in the middle of
another command, push and pop points during commands, change the
current object snap mode, rotate the crosshairs. etc.
or how about an attribute prompt that could call or trigger a
lisp function that would return its results to the attribute !)
 
Use Your imagination folks !
 
One for the Road:
 
(defun divide()
  (polar
    (getvar "lastpoint")
    (getangle (getvar "lastpoint") "\nAngle: ")
    (/
      (getdist "   Overall Distance: ")
      (getreal "   Divided by: ")
    )
  )
)
 
-Tony